#include <stdio.h>


extern struct rtpkt {
  int sourceid;       /* id of sending router sending this pkt */
  int destid;         /* id of router to which pkt being sent 
                         (must be an immediate neighbor) */
  int mincost[4];    /* min cost to node 0 ... 3 */
  };


extern int TRACE;
extern int YES;
extern int NO;

int connectcosts1[4] = { 1,  0,  1, 999 };

struct distance_table 
{
  int costs[4][4];
} dt1;


// caminhos minimos
int mincost1[4];

int noway1=3;
int myself1 = 1;
	
/* students to write the following two routines, and maybe some others */


rtinit1() 
{
	int i;
	int j;

	struct rtpkt packet;


	for (i=0; i<4; i++)
		for (j=0; j<4; j++)
		{
			if (j== noway1 || i == noway1)
				dt1.costs[i][j] = connectcosts1[noway1];		// no sei o caminho
			else
			{
				if (j == myself1)
					dt1.costs[i][j]= connectcosts1[i];
				else if (i == myself1)
					dt1.costs[i][j]= 2 * connectcosts1[j];
				else if (i == j)
					dt1.costs[i][j] = connectcosts1[i];	// link direto
				else 
					dt1.costs[i][j] = connectcosts1[j]* 2 + connectcosts1[i]; // vou para j, volto para 1, e vou para i (i atraves de j)
			}
		}
	
	if (TRACE>1)
	{	printf("\nTabela de distancias inicial do n %d:\n", myself1);
		printdt1(&dt1);
	}

	// acha os caminhos minimos
	for(j=0;j<4;j++)
		mincost1[j] = dt1.costs[j][j];

		
	// envia os caminhos minimos para os vizinhos;
	for (i=0; i<4; i++)
		if (i!= myself1 && i!= noway1)
		{
			packet.destid = i;
			packet.sourceid= myself1;
			for(j=0;j<4;j++) 
				packet.mincost[j] = mincost1[j];

			tolayer2(packet);
		}
}


rtupdate1(rcvdpkt)
  struct rtpkt *rcvdpkt;
  
{
	int change = 0;
	int i, j;
	struct rtpkt packet;
	
	j = rcvdpkt->sourceid;
	
	for(i=0; i<4; i++)
	{
		// se o caminho at J + o caminho at I for menor que o meu caminho minimo at I, atualiza a tabela
		if(mincost1[j] + rcvdpkt->mincost[i] < mincost1[i])
		{
			// atualiza os caminhos minimos
			mincost1[i] = mincost1[j] + rcvdpkt->mincost[i];
			// atualiza a tabela de distancia. Para ir at I atraves de J
			dt1.costs[i][j] = mincost1[i];
			change = 1;
		}
	}

	

				
	if (change)
	{
		if (TRACE>1)
		{	printf("\nTabela de distancias atualizada %d:\n", myself1);			
			printdt1(&dt1);
		}
		for (i=0; i<4; i++)
			if (i!= myself1 && i!= noway1)
			{
				packet.destid = i;
				packet.sourceid= myself1;
				for(j=0;j<4;j++) 
					packet.mincost[j] = mincost1[j];
				tolayer2(packet);
			}
	}
}


printdt1(dtptr)
  struct distance_table *dtptr;
  
{
  printf("             via   \n");
  printf("   D1 |    0     2 \n");
  printf("  ----|-----------\n");
  printf("     0|  %3d   %3d\n",dtptr->costs[0][0], dtptr->costs[0][2]);
  printf("dest 2|  %3d   %3d\n",dtptr->costs[2][0], dtptr->costs[2][2]);
  printf("     3|  %3d   %3d\n",dtptr->costs[3][0], dtptr->costs[3][2]);

}



linkhandler1(linkid, newcost)   
int linkid, newcost;   
/* called when cost from 1 to linkid changes from current value to newcost*/
/* You can leave this routine empty if you're an undergrad. If you want */
/* to use this routine, you'll need to change the value of the LINKCHANGE */
/* constant definition in prog3.c from 0 to 1 */
	
{
}


